% 2D plot of each element of a K-class softmax with a penalty |x-v|

K = 3; v = [-10;10];		% #classes and source instance
% W=randn(K,2); w=randn(K,1);
W=[0 2;2 0;-2 1]; w=[0;-1;1];	% softmax classifier weights
K=length(w);
range=[-30 30;-30 30];		% range of (x1,x2) to plot
%I = {}; paramI = {};		% inequalities (to define a leaf region)
A=[0 0;0 0]; b1=[-1;-1]; c1=20; b2=[1;0]; c2=5; b3=[0;1]; c3=5;
I = {@Fquad,@Fquad,@Fquad}; paramI = {{A,b1,c1},{A,b2,c2},{A,b3,c3}};

% Inefficient: I recompute everything K times so I can use fcontours. But ok
% for doing a few plots.

for l=10.^(0:4)			% penalty
  figure(1); clf;		% softmax
  set(gcf,'Name',['softmax; l=' num2str(l)]);
  for k=1:K
    subplot(1,K,k);
    fcontours(@Fpensoftmax,{W,w,v,l,0,k},{},{},I,paramI,range,100);
    [~,h] = fcontours(@Fsoftmax,{W,w,1},{},{},{},{},range,2);	% class regions
    set(h,'LineWidth',3,'Color','k');
    plotseq(v','rx','LineWidth',3,'MarkerSize',16);
    title(['class k=' num2str(k)]);
  end
  figure(2); clf;		% log-softmax
  set(gcf,'Name',['log-softmax; l=' num2str(l)]);
  for k=1:K
    subplot(1,K,k);
    fcontours(@Fpensoftmax,{W,w,v,l,1,k},{},{},I,paramI,range,100);
    [~,h] = fcontours(@Fsoftmax,{W,w,1},{},{},{},{},range,2);	% class regions
    set(h,'LineWidth',3,'Color','k');
    plotseq(v','rx','LineWidth',3,'MarkerSize',16);
    X = Oqpenalty(@Fpensoftmax,{W,w,v,l,1,k},{},{},I,paramI,...	% minimizer
                  @Onewtoncg,{'linear'},v,[],[],100);
    plotseq(X(end,:),'b+','LineWidth',3,'MarkerSize',16);
    title(['class k=' num2str(k)]);
  end
  pause;
end

